在两个有序的数组中找第N个数,二分查找 O(lgm+lgn)级

简介:

问题描述:

Give a divide and conquer algorithm for the following problem:
you are given two sorted lists of size m and n, and are allowed 
unit time access to the ith element of each list. Give an O(lg m + lgn) 
time algorithm for computing the kth largest element in the union of the  two lists. (For simplicity, you can assume that the elements of the 
two lists are distinct).

问题分析:

1. 把 A 平均分为前后两个部分,前部分有 x 个元素,后部分有 n-x 个元素

(由于 A 是有序的,所以后一部分的所有元素大于前一部分)。A[x] = A的

后一部分的第一个元素。

 


2. 同理把 B 也平均分成前后两个部分,前部分有 y 个元素,后部分有 m-y 个元素。 
B[y] = B的后一部分的第一个元素。


3. 由于两个数组都是被平均分割的,所以可以近似地认为 x = n/2, y = m/2。 
这里不妨设 A[x] <= B[y](如果 A[x] > B[y] 处理过程和下面类似): 

 

part1:

 
由于在 A 中,A[x] 前面有 x 个元素,在 B 中,B[y] 前面有 y 个元素, 
并且又有 A[x] <= B[y],那么,合并以后,A[x]前面原来那些元素必然 
也在B[y]前面,也就是说,B[y]前面至少会有 x + y 个元素,我们再规定 
如果 A, B 中有相同元素,则合并后 A 中的元素排在 B 前面,那么归并 
以后 A[x] 也会排在 B[y] 前面,于是乎合并之后 B[y] 至少有 x+y+1 个元素。 
 
如果 k <= x+y+1,也就是说,合并后第 k 大的元素必然落在 B[y] 前面。 
所以,原来在 B 数组中,第二部分(B[y]以及 B[y] 之后)那些元素都不可能 
包含我们要找到内容(第 k 大元素),所以我们可以把他们排除掉。 
这样就排除了 B 中一半的内容。 
 
 

part2:

 
在 A 中,A[x] 及其后面有 n1-x 个元素,除去 A[x] 之后有 n-x-1 个元素, 
B[y] 及其后面有 m-y 个元素。那么,由于 A[x] <= B[y],所以合并起来之后, 
B[y] 后面那些元素必然也在 A[x] 后面,则合并后 A[x] 后面至少有  
(n-x-1) + (m-y) = (n+m)-(x+y+1) 个元素。 
 
如果 k > x+y+1,也就说,合并后第 k 大的元素必然落在 A[x] 后面。 
所以,原来在 A 数组中,第一部分(A[x]之前)以及 A[x] 都不可能包含我们 
要找的元素,所以我们可以把他们排除掉。这样就排除了 A 中一半的内容。 
 
 

all:

 
综上所诉,对于 k <= x+y+1 还是 k > x+y+1 我们都提出了解决的方案,并且每种方案 
都能把 A 或者 B 的规模减小一半。减小了一半之后,我们将其作为一个新的问题 
继续使用上面的算法处理,直到 A 或者 B 减小到足够小: 
 
1. A没有了,这样只需要找出 B 中第 k 大的元素,也就是 B[k]. 
2. B没有了,同上结果就是 A[k].

 

代码如下:

 

[c-sharp]  view plain copy
  1. /************************************************************************ 
  2.  * This is the practice1 of the Algorithms It solved the problem1 below: 
  3.  *  
  4.  * Give a divide and conquer algorithm for the following problem: 
  5.  * you are given two sorted lists of size m and n, and are allowed  
  6.  * unit time access to the ith element of each list. Give an O(lg m + lgn)  
  7.  * time algorithm for computing the kth largest element in the union of the  
  8.  * two lists. (For simplicity, you can assume that the elements of the  
  9.  * two lists are distinct). 
  10.  *  
  11.  * The idea of the Algorithm in the help file idea.txt!! 
  12.  * 
  13.  * The Algorithm is designed by:Nanne 
  14.  *           
  15.  ************************************************************************/  
  16. #include <iostream>  
  17. using std::cin;  
  18. using std::cout;  
  19. using std::endl;  
  20. int FindTheKth(int a[],int b[],int aLeft, int aRight, int bLeft, int bRight, int k);  
  21.    
  22. int main(){  
  23.     int sizeA,sizeB;  
  24.     int Kth;  
  25.     cout << "AĴС";  
  26.     cin >> sizeA;  
  27.     int *arrA = new int[sizeA];  
  28.     cout << "" << sizeA << "" << endl;  
  29.     for (int i = 0; i < sizeA; i++)   
  30.         cin >> arrA[i];  
  31.     cout << "BĴС";  
  32.     cin >> sizeB;  
  33.     int *arrB = new int[sizeB];  
  34.     cout << "" << sizeB << "" << endl;  
  35.     for (int i = 0; i < sizeB; i++)   
  36.         cin >> arrB[i];  
  37.     while(true){  
  38.         cout << "õڼλ" << endl  
  39.             << "λҪ" << sizeA + sizeB << "(-1Ƴ):";  
  40.         cin >> Kth;  
  41.         if( Kth != -1){  
  42.             int res = FindTheKth(arrA,arrB,0, sizeA - 1, 0, sizeB - 1, Kth);  
  43.             if(res != -1)  
  44.                 cout << "" << Kth << "λǣ" << res << endl;  
  45.         }  
  46.         else  
  47.             return 0;  
  48.     }  
  49. }  
  50.   
  51. int FindTheKth(int a[],int b[],int aLeft, int aRight, int bLeft, int bRight, int k) {  
  52.     int aMid = (aLeft + aRight) / 2, bMid = (bLeft + bRight) / 2;  
  53.     if (aLeft > aRight) return b[bLeft+k-1];  
  54.     if (bLeft > bRight) return a[aLeft+k-1];  
  55.     if (a[aMid] <= b[bMid]) {  
  56.         if (k <= (aMid - aLeft) + (bMid - bLeft) + 1) {  
  57.             return FindTheKth(a,b,aLeft, aRight, bLeft, bMid-1, k);  
  58.         } else {  
  59.             return FindTheKth(a,b,aMid+1, aRight, bLeft, bRight, k-(aMid-aLeft)-1);  
  60.         }  
  61.     } else {  
  62.         if (k <= (aMid - aLeft) + (bMid - bLeft) + 1) {  
  63.             return FindTheKth(a,b,aLeft, aMid-1, bLeft, bRight, k);  
  64.         } else {  
  65.             return FindTheKth(a,b,aLeft, aRight, bMid+1, bRight, k-(bMid-bLeft)-1);  
  66.         }  
  67.     }  
  68.     return -1;  
  69. }  

本文转自博客园知识天地的博客,原文链接:在两个有序的数组中找第N个数,二分查找 O(lgm+lgn)级,如需转载请自行联系原博主。

相关文章
|
3月前
|
算法 测试技术 C#
二分查找:LeetCode2035:将数组分成两个数组并最小化数组和的差
二分查找:LeetCode2035:将数组分成两个数组并最小化数组和的差
|
7月前
|
算法
|
6天前
|
算法 测试技术 Serverless
【二分查找】【C++算法】378. 有序矩阵中第 K 小的元素
【二分查找】【C++算法】378. 有序矩阵中第 K 小的元素
|
1月前
leetcode2967. 使数组成为等数数组的最小代价
leetcode2967. 使数组成为等数数组的最小代价
20 0
|
2月前
|
搜索推荐 算法
在冒泡排序算法中,为什么每次比较相邻的元素时都要进行交换?
【2月更文挑战第8天】【2月更文挑战第21篇】在冒泡排序算法中,为什么每次比较相邻的元素时都要进行交换?
|
3月前
|
算法 测试技术 C#
C++二分查找或并集查找:交换得到字典序最小的数组
C++二分查找或并集查找:交换得到字典序最小的数组
|
3月前
|
存储 算法 Java
数据结构和算法面试题:给定一个整数数组 nums,找到一个具有最大和的连续子数组(子数组最少包含一个元素),返回其最大和。
数据结构和算法面试题:给定一个整数数组 nums,找到一个具有最大和的连续子数组(子数组最少包含一个元素),返回其最大和。
41 0
|
4月前
|
存储 算法 搜索推荐
【算法训练-排序算法 二】【快速排序】数组中的第K个最大元素、最小的K个数
【算法训练-排序算法 二】【快速排序】数组中的第K个最大元素、最小的K个数
33 0
|
4月前
|
算法 程序员 索引
【算法训练-二分查找 一】【基本二分】二分查找、在排序数组中查找元素的第一个和最后一个位置
【算法训练-二分查找 一】【基本二分】二分查找、在排序数组中查找元素的第一个和最后一个位置
27 0
|
4月前
|
算法 测试技术 C++
C++二分查找算法:有序矩阵中的第 k 个最小数组和(一)
C++二分查找算法:有序矩阵中的第 k 个最小数组和